"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var HtmlElementSelectorGenerator_1 = require("./HtmlElementSelectorGenerator");
exports.serialize = function (range, relativeTo) {
    var start = HtmlElementSelectorGenerator_1.generateSelector(range.startContainer, relativeTo);
    start.o = range.startOffset;
    var end = HtmlElementSelectorGenerator_1.generateSelector(range.endContainer, relativeTo);
    end.o = range.endOffset;
    return { s: start, e: end };
};
exports.deserialize = function (result, document) {
    var range = document.createRange();
    var startNode = HtmlElementSelectorGenerator_1.find(result.s, document);
    var endNode = HtmlElementSelectorGenerator_1.find(result.e, document);
    if (startNode.nodeType != Node.TEXT_NODE && startNode.firstChild) {
        startNode = startNode.firstChild;
    }
    if (endNode.nodeType != Node.TEXT_NODE && endNode.firstChild) {
        endNode = endNode.firstChild;
    }
    if (startNode) {
        range.setStart(startNode, result.s.o);
    }
    if (endNode) {
        range.setEnd(endNode, result.e.o);
    }
    return range;
};
//# sourceMappingURL=RangeSerializer.js.map